'' PROPMIDI PLAYER  V2.1  SD & PC STREAMING VERSION
'' BY: Jeff Ledger  April 2009
''
'' Based on "MIDI expander" by Andy Schenk
'' This version requires the setup for Midi Expander as
'' discussed in Andy Schenk's PMSynth thread.
''
'' Thank you Andy for such a great Synth to play with!
'' Thank you to Alex Schafer for FontGenerator! (used here)
''
''************************
''*   MIDI expander      *
''************************
'' Author:   Andy Schenk, Insonix
'' Date:     April 2009

'' uses the PhaseMod GM Synthesizer to play the MIDI events from the RX input.

CON
  _clkmode        = xtal1 + pll16x
  _xinfreq        = 5_000_000

  Left              = 10       '<-- Audio Out pins
  Right             = 11
  Video_basepin     = 12       '<-- Video Basepin      
  Keyboard_basepin  = 26       '<-- Keyboard Basepin

  SD_basepin        = 16       '<-- SD card
  '' If an SD card is not detected player
  '' will default to "PC STREAM" mode.
  
OBJ
  midi  : "FD_Serial_Conf"  'FDserial with 128 byte rx-buffer
  synth : "pm_synth_20"
  text  : "aigeneric_driver" 
  sd    : "fsrw"
  key   : "comboKeyboard"
  
VAR    
  long  time, tq, ts, us
  byte  filename[16]
  byte tbuf[20]
  long songname[16]
  byte songptr[16]
  long songbuff[50]
  byte strbuff[5]
  byte songfile[20]
           
PUB Main | ii,jj
  text.start(Video_basepin)                                        '<-- Display basepin
  synth.start(Left,Right,2)                             'start synth with 20 voices
  
  if\ sd.mount(SD_basepin) < 0                            'init SD card
    text.str(string("SD card not found.",13))
    text.str(string("switching to PC STREAM mode.",13))
    waitcnt(clkfreq*5+cnt)
    PCStream  ''Switch to PC Streaming mode.  

  else ''SD Card detected.  Present list of .MID files.

    key.start(keyboard_basepin)
    repeat
      ii:=0
      text.out(0)
      credits
      text.out(13)
      text.color(12)
      text.out($10)
      text.out($11)
      text.color(13)
      text.str(string(" Type filename below:"))
      text.color(12)
      text.str(string(" ",$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$12,13))
      repeat until ii == 17
        text.str(string($15,"                                      ",$15,13))  
        ii++
      text.str(string($13,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$14,13))
      listfiles
      text.locate(23,1)
      text.color(10)
      text.str(string("[f1] for pcstream or"))
      text.str(string(" ::] "))
      text.color(7)
      bytefill(@songfile,0,14)
      INPUT(@songfile,13)
      midifileplay(@songfile)
    
PRI listfiles | a,b,c,d,e,rfile

  sd.opendir
  
  b := 0
  c := 0
  d := 1
  e := 0

  text.color($04)
  text.locate(10,24)

  text.color($00)
   repeat
     if c > 48
      quit
     if c == 17
       d:=14
       e:=0
     if c == 33
       d:=26
       e:=0  
       
     if sd.nextfile(@tbuf) == -1
      quit
     b++ 
     a:=StrRight(@tbuf,3) 
     if textcomp(a,string("MID"),3) == true
        text.locate(e+5,d)
        text.str(@tbuf)
        c++
        e++
        sd.opendir
        repeat b
           sd.nextfile(@tbuf)

PUB input(data, size) | keystroke,len
   keystroke:=0
   len:=0
   text.out($60)
   repeat' until keystroke == 13 'Exit when Carriage Return is pressed
     keystroke := key.key

      if keystroke == 208 
         PCStream
         
      if keystroke == $C8       ' Check for Backspace Key
        if len > 0
         byte[data--] := 0
         size++
         len--
         text.out(8)
         text.out(32) 'These lines erase the cursor on backspace
         text.out(8)
         
         text.out(8)
         text.out(32)
         text.out(8)
         text.out($60)
         keystroke := 0

      if keystroke == $C8        'Clean up backspace if all is cleared
         keystroke:= 0

      if keystroke == 13
         text.out(8)
         text.out(32)
         text.out(8)
         text.out(13)
         quit
         
      if keystroke > 10 
        if size > 1 and len < 15
          text.out(8)
          text.out(keystroke)
          text.out($60)
          
          ''text.dec(keystroke) 'for troubleshooting
          if keystroke <> 13 
            byte[data++] := keystroke
            size--
            len++

             
PUB PCStream
  midi.start(31,30,0,38400)                             'MIDI input (PropPlug)
  text.out(0)
  credits
  keyboard(1,0,7)  '' display keyboard channel 1
  keyboard(2,0,7)  '' display keyboard channel 2
  keyboard(3,0,7)  '' display keyboard channel 3
  keyboard(4,0,7)  '' display keyboard channel 4
  keyboard(5,0,7)  '' display keyboard channel 5
  musicalnotes(6,0)
  text.str(string(13,13,"         Playing: "))
  text.color(14)
  text.str(string("PC STREAM"))   ''Replace with actual file name in SD version
  text.color(7)

  midiplay
  repeat
   
pub musicalnotes(channel,note)

  if channel == 8
     text.color(note)
  text.locate(6,3)
  text.outkeys($27)

  if channel == 12
     text.color(note)
  text.locate(9,2)
  text.outkeys($27)
  
  if channel == 6
     text.color(note)     
  text.locate(13,2)
  text.outkeys($27)

  if channel == 10
     text.color(note)
  text.locate(21,3)
  text.outkeys($27)

  if channel == 10
     text.color(note)
  text.locate(5,36)
  text.outkeys($27)

  if channel == 9
     text.color(note)
  text.locate(14,35)
  text.outkeys($27)

  if channel == 7
     text.color(note)
  text.locate(17,36)
  text.outkeys($27)

  if channel == 13
     text.color(note)
  text.locate(22,35)
  text.outkeys($27)
  
pub credits
  text.out($16) '' General Midi Logo
  text.out($17)
  text.out($18) '' GENERAL
  text.out($19)   
  text.out(13)
  text.out($07) '' M
  text.out($09) '' I  Top of Logo
  text.out($0A) '' D
  text.out($0B) '' I
  text.color(13)
  text.str(string(" PropMidi Player by Jeff Ledger"))   
  text.color(7)
  text.out(13)
  text.out($28) '' M
  text.out($29) '' I  Bottom of Logo
  text.out($2A) '' D
  text.out($2B) '' I
  text.color(12)
  text.str(string(" using pmsynth by Andy Schenk")) 
  text.color(7)
  text.out(13)

pub keyboard(channel,note,instrument)

  if note < 36 and note > 1
     note:=note+48
     'instrument:=5
     if channel < 5
        channel++
     
  if note > 83
     note:=note-48
     'instrument:=4   
     if channel > 1
        channel--
     
  if channel == 1
     text.locate(5,5)
  if channel == 2
     text.locate(9,5)
  if channel == 3
     text.locate(13,5)
  if channel == 4
     text.locate(17,5)
  if channel == 5
     text.locate(21,5)

  if note == 36
     text.color(instrument)            
  text.outkeys($04) 'top of C0
  if note == 38
     text.color(instrument)
  text.outkeys($05) 'top of D0
  if note == 40
     text.color(instrument)
  text.outkeys($06) 'top of E0
  if note == 41
     text.color(instrument)
  text.outkeys($04) 'top of F0
  if note == 43
     text.color(instrument)
  text.outkeys($01) 'top of G0
  if note == 45
     text.color(instrument)
  text.outkeys($01) 'top of A0
  if note == 47
     text.color(instrument)
  text.outkeys($06) 'top of B0

  if note == 48
     text.color(instrument)
  text.outkeys($04) 'top of C1
  if note == 50
     text.color(instrument)
  text.outkeys($05) 'top of D1
  if note == 52
     text.color(instrument)
  text.outkeys($06) 'top of E1
  if note == 53
     text.color(instrument)
  text.outkeys($04) 'top of F1
  if note == 55
     text.color(instrument)
  text.outkeys($01) 'top of G1
  if note == 57
     text.color(instrument)
  text.outkeys($01) 'top of A1
  if note == 59
     text.color(instrument)
  text.outkeys($06) 'top of B1

  if note == 60
     text.color(instrument)
  text.outkeys($04) 'top of C2
  if note == 62
     text.color(instrument)
  text.outkeys($05) 'top of D2
  if note == 64
     text.color(instrument)
  text.outkeys($06) 'top of E2
  if note == 65
     text.color(instrument)
  text.outkeys($04) 'top of F2
  if note == 67
     text.color(instrument)
  text.outkeys($01) 'top of G2
  if note == 69
     text.color(instrument)
  text.outkeys($01) 'top of A2
  if note == 71
     text.color(instrument)
  text.outkeys($06) 'top of B2

  if note == 72
     text.color(instrument)
  text.outkeys($04) 'top of C3
  if note == 74
     text.color(instrument)
  text.outkeys($05) 'top of D3
  if note == 76
     text.color(instrument)
  text.outkeys($06) 'top of E3
  if note == 77
     text.color(instrument)
  text.outkeys($04) 'top of F3
  if note == 79
     text.color(instrument)
  text.outkeys($01) 'top of G3
  if note == 81
     text.color(instrument)
  text.outkeys($01) 'top of A3
  if note == 83
     text.color(instrument)
  text.outkeys($06) 'top of B3

  
  if channel == 1
     text.locate(6,5)
  if channel == 2
     text.locate(10,5)
  if channel == 3
     text.locate(14,5)
  if channel == 4
     text.locate(18,5)
  if channel == 5
     text.locate(22,5)

  if note == 36
     text.color(instrument)
  text.outkeys($22) 'bottom of C0
  if note == 38
     text.color(instrument)
  text.outkeys($23) 'bottom of D0
  if note == 40
     text.color(instrument)
  text.outkeys($24) 'bottom of E0
  if note == 41
     text.color(instrument)
  text.outkeys($25) 'bottom of F0
  if note == 43
     text.color(instrument)
  text.outkeys($1f) 'bottom of G0
  if note == 45
     text.color(instrument)
  text.outkeys($1f) 'bottom of A0
  if note == 47
     text.color(instrument)
  text.outkeys($24) 'bottom of B0

  if note == 48
     text.color(instrument)
  text.outkeys($22) 'bottom of C1
  if note == 50
     text.color(instrument)
  text.outkeys($23) 'bottom of D1
  if note == 52
     text.color(instrument)
  text.outkeys($24) 'bottom of E1
  if note == 53
     text.color(instrument)
  text.outkeys($25) 'bottom of F1
  if note == 55
     text.color(instrument)
  text.outkeys($1f) 'bottom of G1
  if note == 57
     text.color(instrument)
  text.outkeys($1f) 'bottom of A1
  if note == 59
     text.color(instrument)
  text.outkeys($24) 'bottom of B1

  if note == 60
     text.color(instrument)
  text.outkeys($22) 'bottom of C2
  if note == 62
     text.color(instrument)
  text.outkeys($23) 'bottom of D2
  if note == 64
     text.color(instrument)
  text.outkeys($24) 'bottom of E2
  if note == 65
     text.color(instrument)
  text.outkeys($25) 'bottom of F2
  if note == 67
     text.color(instrument)
  text.outkeys($1f) 'bottom of G2
  if note == 69
     text.color(instrument)
  text.outkeys($1f) 'bottom of A2
  if note == 71
     text.color(instrument)
  text.outkeys($24) 'bottom of B2

  if note == 72
     text.color(instrument)
  text.outkeys($22) 'bottom of C3
  if note == 74
     text.color(instrument)
  text.outkeys($23) 'bottom of D3
  if note == 76
     text.color(instrument)
  text.outkeys($24) 'bottom of E3
  if note == 77
     text.color(instrument)
  text.outkeys($25) 'bottom of F3
  if note == 79
     text.color(instrument)
  text.outkeys($1f) 'bottom of G3
  if note == 81
     text.color(instrument)
  text.outkeys($1f) 'bottom of A3
  if note == 83
     text.color(instrument)
  text.outkeys($24) 'bottom of B3
  text.out(13)
    
PRI textComp(str1,str2,len)
   repeat len
      if byte[str1++] <> byte[str2++]
         return false
   return true

PRI StrRight(str,len) | i,l,z,j

  l:=strSize(str)
  z:=0
  repeat i from l-len to l
    strbuff[z] := byte[@tbuf][i]
    z++
  return @strbuff


PUB midiplay  | lg, dt, b, v, st, d1, d2, ch,instr,note
  b := st := d1 := d2 := v := 0
  repeat
    b := midi.rx                                  'MIDI byte
    if b > 127 and b < $F0
      st := b                                     'new status byte
    ch := st & $0F
    d1~
    d2~
    case st & $F0                                 'decode MIDI Event
      $90: d1 := midi.rx                          'Note 
           d2 := midi.rx                          'Velocity
           if d2>0
             synth.noteOn(d1,ch,d2)               'Note On
             ch++  'fix issue with channels -jl
             if ch == 1 or ch== 2 or ch == 3 or ch == 4 or ch == 5
                keyboard(ch,d1,ch+9)
             if ch > 5
                musicalnotes(ch,d1)
             note:=d1   
           else
             synth.noteOff(d1,ch)                 'Note Off if Vel=0
             if ch == 1 or ch == 2 or ch == 3 or ch == 4 or ch == 5
                keyboard(ch,0,7)

                
      $80: d1 := midi.rx                          'Note Off 
           d2 := midi.rx                          'Velocity
           synth.noteOff(d1,ch)
           if ch == 1 or ch == 2 or ch == 3 or ch == 4 or ch == 5
              keyboard(ch,0,7)

             
      $A0: d1 := midi.rx                          'Poly AfterTouch 
           d2 := midi.rx                          '(not supported)
      $C0: d1 := midi.rx                          'Prg Change 
           synth.prgChange(d1,ch)
           instr:=d1
      $D0: d1 := midi.rx                          'Mono AfterTouch 
      $B0: d1 := midi.rx                          'Controller (nr) 
           d2 := midi.rx                          'value
           if d1==7
             synth.volContr(d2,ch)                '7=Vol
           if d1==10
             synth.panContr(d2,ch)                '10=Pan
           if d1==120
             synth.allOff                         'AllNotes Off
             keyboard(1,0,7)
             keyboard(2,0,7)
             keyboard(3,0,7)
             keyboard(4,0,7)
             keyboard(5,0,7)
      $E0: d1 := midi.rx                          'Pitch Bender 
           d2 := midi.rx                          '(not supported!)
      $F0: if st==$F0                             'SysEx
             repeat
               v := midi.rx  
             until v==$F7
             d1~
           elseif st==$F2
             d1 := midi.rx                        '3 byte
             d2 := midi.rx  

PUB midifileplay(name)  | lg, dt, b, v, st, d1, d2, ch,keystroke,note
  us := clkfreq / 1_000_000                             'ticks / microsecond
  text.out(0)
  credits
  keyboard(1,0,7)  '' display keyboard channel 1
  keyboard(2,0,7)  '' display keyboard channel 2
  keyboard(3,0,7)  '' display keyboard channel 3
  keyboard(4,0,7)  '' display keyboard channel 4
  keyboard(5,0,7)  '' display keyboard channel 5
  musicalnotes(6,0)
  text.str(string(13,13,"         Playing: "))
  text.color(14)
  text.str(name)   ''Replace with actual file name in SD version
  text.color(7)


  b := st := d1 := d2 := v := 0
  ifnot sd.popen(name,"r")
    sd.pread(@v,4)
    if v == "M" + "T"<<8 + "h"<<16 + "d"<<24            'Header ID
      sd.pread(@v,4)                                    'Header Len
      v~
      sd.pread(@v,2)                                    'Format
      if v <> 0
        text.str(string("only Format 0 supported"))
      else
        sd.pread(@v,2)                                  'Tracks
        sd.pread(@v,2)                                  'Ticks/Quarter
        tq := v>>8 + (v&255)<<8
        ts := 500_000 / tq                              'default Tempo 120 BPM
        sd.pread(@v,4)                                  '"MTrk"
        sd.pread(@v,4)                                  'Track length
        lg := v>>24 + (v>>16&255)<<8 + (v>>8&255)<<16
        time := cnt
        repeat
          sd.pread(@b,1)                                'get delta time
          lg--
          dt := b & $7F
          repeat while b>127
            sd.pread(@b,1)
            lg--
            dt := dt<<7 + (b & $7F)
          time := time + dt*us*ts
          repeat until time-cnt < 0                     'wait deltatime
          b~
          sd.pread(@b,1)                                'MIDI byte
          if b > 127
            st := b                                     'new status byte
          elseif st==$FF
            st~
          ch := st & $0F
          d1~
          d2~
          case st & $F0                                 'decode MIDI Event
            $90: sd.pread(@d1,1)                        'Note 
                 sd.pread(@d2,1)                        'Velocity
                 lg -= 3
                 if d2>0
                   synth.noteOn(d1,ch,d2)               'Note On
                   ch++ 'fixed issue with channels -jl
                   if ch == 1 or ch== 2 or ch == 3 or ch == 4 or ch == 5
                      keyboard(ch,d1,ch+9)
                   if ch > 5
                      musicalnotes(ch,d1)
                   note:=d1
                      
                   keystroke := key.key
                   if keystroke == 32
                      lg:=-1

                 else
                   synth.noteOff(d1,ch)                 'Note Off if Vel=0
                   if ch == 1 or ch == 2 or ch == 3 or ch == 4 or ch == 5
                       keyboard(ch,0,7)
   
            $80: sd.pread(@d1,1)                        'Note Off 
                 sd.pread(@d2,1)                        'Velocity
                 lg -= 3
                 synth.noteOff(d1,ch)
                 if ch == 1 or ch == 2 or ch == 3 or ch == 4 or ch == 5
                    keyboard(ch,0,7)

            $A0: sd.pread(@d1,1)                        'Poly AfterTouch 
                 sd.pread(@d2,1)                        '(not supported)
                 lg -= 3
            $C0: sd.pread(@d1,1)                        'Prg Change 
                 lg -= 2
                 synth.prgChange(d1,ch)
                 'show(0,ch+1,string("Ch:"),ch+1)
                 'show(6,ch+1,string("Prg:"),d1)
            $D0: sd.pread(@d1,1)                        'Mono AfterTouch 
                 lg -= 2                                '(not supported)
            $B0: sd.pread(@d1,1)                        'Controller (nr) 
                 sd.pread(@d2,1)                        'value
                 lg -= 3
                 if d1==7
                   synth.volContr(d2,ch)                '7=Vol
                 if d1==10
                   synth.panContr(d2,ch)                '10=Pan
                 if d1==120
                      synth.allOff                         'AllNotes Off
                      keyboard(1,0,7)
                      keyboard(2,0,7)
                      keyboard(3,0,7)
                      keyboard(4,0,7)
                      keyboard(5,0,7)


            $E0: sd.pread(@d1,1)                        'Pitch Bender 
                 sd.pread(@d2,1)                        '(not supported!)
                 lg -= 3
            $F0: sd.pread(@d1,1)                        'Meta Event
                 v~
                 if st==$F0 or st==$F7                  'SysEx
                   repeat
                     sd.pread(@v,1)
                     lg--
                     d1--
                   until v==$F7 or b=< 0
                   d1~
                 else
                   lg -= 2
                   sd.pread(@b,1)                       'Len
                   repeat while b>0                     'read meta data
                     sd.pread(@d2,1)
                     v := v<<8 + d2
                     b--
                     lg--
                   if d1==81                            'Tempo
                     ts := v / tq
            0:   sd.pread(@d1,1)                        'Meta Event Running status
                 lg -= 2
                 sd.pread(@b,1)                         'Len
                 repeat while b>0                       'read meta data
                   sd.pread(@d2,1)
                   v := v<<8 + d2
                   b--
                   lg--
            
        until lg < 1
    else
      text.str(string("No MIDI file"))
    sd.pclose
    synth.allOff
  else
    text.str(string("File not found"))
     
  